#include "moduleArchiveInvoices.h"

void createInvoice (GtkWidget *widget, xdfConnModule *conn_mod) 
{
  InvoiceTax invoice;
  PGresult *res[2];
  GString *query = g_string_new ("");
  GString *people= g_string_new ("");
  FILE *fp;
  int line_count;
  int a,b,c; // dla petli, TYLKO!!
  char option[256], version[9];
  int lp;
  Tax w_tax;
  Tax w_brutto;
  char words[128];
  extern GtkWidget *entry_invoice_number,
									 *entry_invoice_sort,
									 *entry_invoice_prefix;
	struct xdfDialogMsgStruct msg_struct;

  line_count = 0;
  w_brutto   = 0;
  w_tax      = 0;

  initTax (&invoice);

  chdir (getenv ("HOME"));
  fp = fopen (INVOICE_NAME, "w");

  /* 
   * Zmieniam kodowanie na LATIN2, dzieki czemu
   * wrzutki towarw o nazwach w polskich znakach
   * nie powoduja zmian w wydruku (rozhodzenie tabeli)
   */
  
   PQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'LATIN2';");

   g_string_printf (query, "SELECT 
			     invoices.place,
			     invoices.print_date, 
			     invoices.sell_date,
			     clients.name,
			     clients.street,
			     clients.postal_code,
			     clients.city,
			     clients.nip,
			     kinds_of_pay.name,
			     (invoices.term_of_pay - invoices.sell_date),
			     invoices.term_of_pay,
			     invoices.orders,
			     invoices.nr_wz,
			     users.fullname,
			     invoices.people_get,
			     clients.discount
			     FROM invoices, kinds_of_pay, clients, users
			     WHERE 
			     invoices.number='%s' and
			     invoices.kinds_of_pay=kinds_of_pay.id and
			     invoices.prefix_number='%s' and
			     users.id=invoices.users_id and
			     clients.id=invoices.clients_id and
			     invoices.is_active='TRUE' and
			     clients.is_active='TRUE';",
					 ENTRY_GET_TEXT (entry_invoice_number),
					 ENTRY_GET_TEXT (entry_invoice_prefix));

  res[0] =  PQexec (conn_mod->conn, query->str);

  fputs("+", fp);
  for(a=1; a < 39; a++)
    fputs("-", fp);
  fputs("+", fp);
  fputs("\n", fp);
  for(b=1; b < 8; b++){
    fputs("|", fp);
    for(a=1; a < 39; a++)
    fputs(" ", fp);
    fputs("|", fp);
    for(c=1; c < 30; c++)
    fputs(" ", fp);
    switch (b){
      case 1: fputs("MIEJSCE WYSTAWIENIA : ", fp); 
	      fputs (PQgetvalue (res[0], 0, 0), fp);
	      break;
      case 2: fputs("DATA WYSTAWIENIA    : ", fp);
	      fputs (PQgetvalue (res[0], 0, 1), fp);
	      break;
      case 3: fputs("DATA SPRZEDAY      : ",  fp);
	      fputs (PQgetvalue (res[0], 0, 2), fp);
	      break;
    }
    fputs("\n", fp);
  }
  fputs("+", fp);
  fputs("-", fp);
  fputs("-", fp);

  fputs("Piecz firmy", fp);
  for(a=1; a < 24;a++)
    fputs("-", fp);
  fputs("+", fp);
  fputs("\n", fp);
  fputs("\n", fp);
  fputs("\n", fp);
	
  for(a=1; a < 41; a++)
    fputs(" ", fp);	
    fputs("[ O R Y G I N A  / K O P I A ]", fp);
    fputs("\n", fp);
    fputs("\n", fp);
  
    g_string_printf (people, "%-80s%s", PQgetvalue (res[0], 0, 14), PQgetvalue (res[0], 0, 13));
    
  fputs ("\n", fp);
  fputs ("\n", fp);
  fputs ("SPRZEDAWCA\n", fp);
  search (SPRZEDAWCA, "nazwa_firmy", option);
    fputs (option, fp);
    fputs (" ", fp);
    search (SPRZEDAWCA, "wlasciciel", option);
    fputs (option, fp);
    fputs ("\n", fp);
  search (SPRZEDAWCA, "ulica", option);
    fputs ("ul. ", fp);
    fputs (option, fp);
    fputs ("\n", fp);
  search (SPRZEDAWCA, "kod_pocztowy", option);
    fputs (option, fp);
    fputs (" ", fp);
    search (SPRZEDAWCA, "miejscowosc", option);
    fputs (option, fp);
    fputs ("\n", fp);
  fputs ("NIP: ", fp);
    search (SPRZEDAWCA, "nip", option);
    fputs (option, fp);
    fputs ("\n", fp);
  fputs ("Tel: ", fp);
    search (SPRZEDAWCA, "tel", option);
    fputs (option, fp);
    fputs ("\n", fp);
  fputs ("Fax: ", fp);
    search (SPRZEDAWCA, "fax", option);
    fputs (option, fp);
    fputs ("\n", fp);
  fputs ("Konto   : ", fp);
    search (SPRZEDAWCA, "konto", option);
    fputs (option, fp);
    fputs ("\n", fp);
  fputs ("Nr konta: ", fp);
    search (SPRZEDAWCA, "nr_konta", option);
    fputs (option, fp);
    fputs ("\n", fp);
  
    
  fputs ("\n", fp);
  fputs ("\n", fp);


  for (a=0; a < 38; a++)
    fputs (" ", fp);

  if (strcmp (ENTRY_GET_TEXT (entry_invoice_sort), "Faktura VAT") == 0)
    fputs ("F A K T U R A   V A T   N R : ", fp);
  else
    fputs ("F A K T U R A   V A T - P R O F O R M A   N R : ", fp);

		fputs (ENTRY_GET_TEXT (entry_invoice_prefix), fp);
		fputs (ENTRY_GET_TEXT (entry_invoice_number), fp);
    fputs ("\n", fp);

  fputs ("\n", fp);
  fputs ("\n", fp);


  fputs ("NABYWCA\n", fp);
    fputs (PQgetvalue (res[0], 0, 3), fp);
    fputs ("\n", fp);
    fputs (PQgetvalue (res[0], 0, 4), fp);
    fputs ("\n", fp);
    fputs (PQgetvalue (res[0], 0, 5), fp);
    fputs (PQgetvalue (res[0], 0, 6), fp);
    fputs ("\n", fp);
    fputs ("NIP: ", fp);
    fputs (PQgetvalue (res[0], 0, 7), fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    
    
  fputs ("Sposb zapaty     : ", fp);
    fputs (PQgetvalue (res[0], 0, 8), fp);
    fputs (" ", fp);
    if (strcmp (PQgetvalue (res[0], 0, 8), "Przelew") == 0) {
      fputs (PQgetvalue (res[0], 0, 9), fp);
      fputs (" dni\n", fp);
    } else
      fputs ("\n", fp);

  fputs ("Termin zapaty     : ", fp);
    fputs (PQgetvalue (res[0], 0, 10), fp);
    fputs ("\n", fp);

  fputs ("Nr zamwienia      : ", fp);
    fputs (PQgetvalue (res[0], 0, 11), fp);
    fputs ("\n", fp);

  fputs ("Nr dokumentu W-Z   : ", fp);
    fputs (PQgetvalue (res[0], 0, 12), fp);
    fputs ("\n", fp);

    
  fputs ("\n", fp);
  fputs ("\n", fp);
  fputs ("\n", fp);

  fputs ("+", fp);
  for (a=0; a < 109; a++)
    fputs ("=", fp);
  fputs ("+\n", fp);
  fputs("|  |                               |              |   |       | Cena    |Ra| Warto  |   | Kwota  | Warto  |\n", fp);
  fputs("|Lp|    Nazwa  towaru  / usugi    |     PKWiU    |jm | Ilo |jedn. bez|ba|   bez    |VAT|podatku | towaru z |\n", fp);
  fputs("|  |                               |              |   |       | podatku |t%| podatku  |[%]|        |podatkiem |\n", fp);
  fputs("+==|===============================|==============|===|=======|=========|==|==========|===|========|==========+\n", fp);			

  g_string_printf (query, "SELECT goods.name,
				  goods.sww,
				  units.name,
				  invoice_goods.quantity,
				  (1 - discounts.discount * 0.01) * goods_data.sell_price,
				  goods_data.tax_vat,
				  states_of_goods.name,
				  discounts.discount
			   FROM
	   invoice_goods, goods, units, goods_data, states_of_goods, discounts
			   WHERE
			  discounts.invoice_goods_id=invoice_goods.id and
			  states_of_goods.id=goods.states_of_goods_id and
				  goods.id=invoice_goods.goods_id and
				  goods_data.goods_id=goods.id and
				  goods.units_id=units.id and
  invoice_goods.invoices_id=(SELECT id FROM invoices WHERE number='%s' and is_active='TRUE' and invoices_kind_id=(SELECT id FROM invoices_kind WHERE name = '%s'));",
					ENTRY_GET_TEXT (entry_invoice_number),
					ENTRY_GET_TEXT (entry_invoice_sort));

  res[1] = PQexec (conn_mod->conn, query->str);
 
  lp=0;

      
  for (a=0; a < PQntuples (res[1]); a++) {
    lp++;
    g_string_printf (query, "|%2.0d|", lp);
      fputs (query->str, fp);

    g_string_printf (query, "%-31s|", PQgetvalue (res[1], a, 0));
      fputs (query->str, fp);

    g_string_printf (query, "%14s|", PQgetvalue (res[1], a, 1));
      fputs (query->str, fp);

    g_string_printf (query, "%3s|", PQgetvalue (res[1], a, 2));
      fputs (query->str, fp);

    g_string_printf (query, "%7.2f|", fix5 (atof (PQgetvalue (res[1], a, 3))));
      fputs (query->str, fp);

    g_string_printf (query, "%9.2f|", fix5 (atof (PQgetvalue (res[1], a, 4))));
      fputs (query->str, fp);

    g_string_printf (query, "%2d|", atoi (PQgetvalue (res[1], a, 7)));
      fputs (query->str, fp);

    /* Wartosc netto */
    w_tax      = fix5 (fix5 (atof (PQgetvalue (res[1], a, 3))) *
		    fix5 (atof (PQgetvalue (res[1], a, 4))) );

    /* Wartosc brutto */
    w_brutto   = fix5 (0.01 * fix5 (w_tax) * fix5 ( atof (PQgetvalue (res[1], a, 5))));
      
    g_string_printf (query, "%10.2f|", 
		             fix5 ( w_tax));
    fputs (query->str, fp);
      
    if (strcmp ("bez podatku", PQgetvalue (res[1], a, 6)) == 0) {
      g_string_printf (query, "%3s|", "zw");
      addValueWithoutTax (-1, 
			  fix5 (w_tax),
			  &invoice);
      addValueWithTax (-1,
		       fix5 (w_brutto) + fix5(w_tax),
		       &invoice);
    } else {
      g_string_printf (query, "%3s|", PQgetvalue (res[1], a, 5));
      addValueWithoutTax (atoi (PQgetvalue (res[1], a, 5)), 
			  fix5 (w_tax),
			  &invoice);
      addValueWithTax (atoi (PQgetvalue (res[1], a, 5)),
		       fix5 (w_brutto) + fix5(w_tax),
		       &invoice);
    }
    fputs (query->str, fp);

    g_string_printf (query, "%8.2f|", fix5 (w_brutto)); 
      fputs (query->str, fp);

    g_string_printf (query, "%10.2f|", fix5 (fix5 (w_tax) + fix5 (w_brutto)));
      fputs (query->str, fp);


    fputs ("\n", fp);
  }


  fputs ("+", fp);
  for (a=0; a < 109; a++)
    fputs ("-", fp);
  fputs ("+", fp);
  fputs ("\n", fp);


  for (a=0; a < 69; a++)
    fputs (" ", fp);
  fputs ("RAZEM :", fp);
    g_string_printf (query, "%10.2f     ", fix5 (getAllValueWithoutTax (&invoice)));
    fputs (query->str, fp);
    g_string_printf (query, "%8.2f ", getAllValueWithTax (&invoice) - getAllValueWithoutTax (&invoice)); 
    fputs (query->str, fp);
    g_string_printf (query, "%10.2f", fix5 (getAllValueWithTax (&invoice)));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 60; a++)
    fputs (" ", fp);
  for (a=0; a < 51; a++)
    fputs ("-", fp);

  fputs ("\n", fp);

  for (a=0; a < 69; a++)
    fputs (" ", fp);
  fputs ("W TYM : ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (22, &invoice));
    fputs (query->str, fp);
    fputs ("  22 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (22, &invoice) - getValueWithoutTax (22, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (22, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (7, &invoice));
    fputs (query->str, fp);
    fputs ("   7 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (7, &invoice) - getValueWithoutTax (7, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (7, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (3, &invoice));
    fputs (query->str, fp);
    fputs ("   3 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (3, &invoice) - getValueWithoutTax (3, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (3, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (0, &invoice));
    fputs (query->str, fp);
    fputs ("   0 ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (0, &invoice) - getValueWithoutTax (0, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (0, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  for (a=0; a < 77; a++)
    fputs (" ", fp);

  g_string_printf (query, "%9.2f", getValueWithoutTax (-1, &invoice));
    fputs (query->str, fp);
    fputs ("  zw ", fp);
    g_string_printf (query, "%8.2f", getValueWithTax (-1, &invoice) - getValueWithoutTax (-1, &invoice));
    fputs (query->str, fp);
    g_string_printf (query, "%11.2f", getValueWithTax (-1, &invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);

  fputs ("\n", fp);
  fputs ("\n", fp);
    search (XDEFACTOR_NG, "info_text", option);
    fputs (option, fp);
  fputs ("\n", fp);
  fputs ("\n", fp);

  fputs ("DO ZAPATY:       ", fp);
    g_string_printf (query, "%12.2f z", getAllValueWithTax (&invoice));
    fputs (query->str, fp);
    fputs ("\n", fp);
    
    for(a=0; a < 112; a++)
      fputs ("=", fp);
    fputs ("\n", fp);
    inWords (getAllValueWithTax (&invoice), words);

    g_string_printf (query, "SOWNIE : %s\n", words);
    fputs (query->str, fp);
    for(a=0; a < 112; a++)
      fputs ("=", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);

    fputs (people->str, fp);
    fputs ("\n", fp);
    for (a=0; a < 30; a++)
      fputs (".", fp);
    for (a=0; a < 50; a++)
      fputs (" ", fp);
    for (a=0; a < 30; a++)
      fputs (".", fp);
    fputs ("\n", fp);

    fputs ("Podpis osoby uprawnionej do", fp);
    for (a=0; a < 53; a++)
      fputs (" ", fp);
    fputs ("Podpis osoby uprawnionej do", fp);
    fputs ("\n", fp);
    fputs ("otrzymania faktury VAT", fp);
    for (a=0; a < 58; a++)
      fputs (" ", fp);
    fputs ("wystawienia faktury VAT", fp);
    

    fputs ("\n", fp);
    fputs ("\n", fp);
    fputs ("\n", fp);
    search (XDEFACTOR_NG_INFO, "version", version);
    search (XDEFACTOR_NG_INFO, "author", option);

    fputs ("\n", fp);
    fputs ("\n", fp);
    g_string_printf (query, "Wydruk wykonano w programie XdeFactor-ng %s autorstwa %s", version, option);

    fputs (query->str, fp);
    
  /* Zamykam  plik */
  fclose (fp);
  /* Powracam znowu do UNICODU */
  PQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'UNICODE';");

  search (XDEFACTOR_NG, "print_command", option);
  /* Tu mozna dorzucic rm */
  g_string_printf (query, "%s %s", option, INVOICE_NAME);
  system (query->str);

	msg_struct.msg = g_string_new ("Archiwalna faktura zostala wydrukowana!! \n\n\t XdeFactor-ng");
	  msg_struct.type = GTK_MESSAGE_INFO;
	  xdfDialogMsg (&msg_struct);

  g_string_free (query,  TRUE);

  g_string_free (people, TRUE);
} 
