#include "moduleInvoices.h"

#define USLUGA 2

void addGoods (GtkWidget *widget, xdfConnModule *conn_mod)
{
  extern GtkWidget *entry10,
		   *entry_sum,
		   *entry_discount,
		   *clist4;
  PGresult *res;  
  GString *string_query = g_string_new ("");
  GString *string_id = g_string_new ("");
  GString *string_discount = g_string_new ("");
  struct xdfDialogMsgStruct msg_struct;
  gchar *result[2][7];
  double price, quantity, tax, w_brutto;
  double help;
  int discount;

/* sprawdzam czy user zaznaczyl towar */
  if ((conn_mod->id_goods != -1) && (conn_mod->clients_row != -1)) {
	  
  updateGoodsClist (conn_mod);

  /* ilosc towaru */
  quantity = atof (ENTRY_GET_TEXT (entry10));
 
  msg_struct.title = g_string_new ("Raport ");
  msg_struct.type = GTK_MESSAGE_WARNING;

	/* Sprawdzam, czy wybrany jest towar, czy usluga */
	g_string_printf (string_query, 
						"SELECT goods.kinds_of_goods_id, goods_data.store_state 
				     FROM
					   goods, goods_data
				     WHERE
					   goods_data.no = '%d'
		  and	   goods.id = goods_data.goods_id
	    and	   goods.is_active = 'TRUE';",
					   conn_mod->id_goods);
					   
	res = PQexec (conn_mod->conn, string_query->str);
	
  
	/* Jezeli w magazynie jest wystarczajaca ilosc towaru */
	if ((((atof (ENTRY_GET_TEXT (entry10))) <= (atof (PQgetvalue (res, 0, 1)))) && (atoi (PQgetvalue (res, 0, 0)) != USLUGA)) || ((atoi (PQgetvalue (res, 0, 0)) == USLUGA))){
		if (atoi (PQgetvalue (res, 0, 0)) != USLUGA) {
		  /* usuwamy towar z magazynu */ 
	    g_string_printf (string_query, "UPDATE goods_data
				    SET
				    store_state='%f'
				    WHERE
				    no='%d';",
			  	  ( atof (PQgetvalue (res, 0, 1)) - atof ( ENTRY_GET_TEXT (entry10)) ), conn_mod->id_goods);
 		  PQexec (conn_mod->conn, string_query->str);
		}		   
 		g_string_printf (string_id, "%d", conn_mod->id_goods);
 	  result[1][0] = string_id->str;


    g_string_printf (string_query, "SELECT goods.name,
								   goods_data.sell_price,
					  			 goods_data.tax_vat
					  		   FROM
								   goods, goods_data
								   WHERE
						  		 goods_data.no = '%d'
								   and	   goods.id = goods_data.goods_id
								   and	   goods.is_active = 'TRUE';",
								   conn_mod->id_goods);
					   
	  res = PQexec (conn_mod->conn, string_query->str);

   	discount = atoi (ENTRY_GET_TEXT (entry_discount));
    price = atof (PQgetvalue (res, 0, 1));

 	  result[1][1] = PQgetvalue (res, 0, 0);
    if (!discount) {
 	    result[1][2] = PQgetvalue (res, 0, 1);
    } else {
    g_string_printf (string_discount, "%.2f", 
      fix5 ((1 - discount * 0.01) * price));
    result[1][2] = string_discount->str;
      price = fix5 ((1 - discount * 0.01) * price);
    }
	

    result[1][3] = (char *)ENTRY_GET_TEXT (entry10);
    result[1][4] = PQgetvalue (res, 0, 2);
      tax = atof (PQgetvalue (res, 0, 2));

    w_brutto = fix5 ( fix5 (price) * fix5 (quantity) * (1 + 0.01 * tax));    
    help = fix5 (atof (ENTRY_GET_TEXT (entry_sum)));
    help += w_brutto;
    g_string_printf (string_query, "%.2f", help);
    ENTRY_SET_TEXT (entry_sum, string_query->str);

    g_string_printf (string_query, "%.2f", w_brutto);
    result[1][5] = string_query->str;
    result[1][6] = (char *)ENTRY_GET_TEXT (entry_discount);
    
    gtk_clist_append (GTK_CLIST (clist4), result[1]);
  } else {
    msg_struct.msg = g_string_new ("");
    g_string_printf (msg_struct.msg, "W magazynie jest tylko %s danego towaru !! \n\n Nie mozesz odjac wiecej niz jest !! \n\n\t XdeFactor-ng", PQgetvalue (res, 0, 1));
    xdfDialogMsg (&msg_struct);
    g_string_free (msg_struct.title, TRUE);
    g_string_free (msg_struct.msg  , TRUE);
  }

  g_string_free (string_query, TRUE);
  g_string_free (string_id, TRUE);
  g_string_free (string_discount, TRUE);
  
  ENTRY_SET_TEXT (entry10, "");

  updateGoodsClist (conn_mod);
  }
}
