#include "moduleInvoices.h"

void initTax (InvoiceTax *inv) 
{
  int i;

  for (i = 0; i < TAX_QUANTITY; i++) {
    inv->value_without_tax[i] = 0;
    inv->value_with_tax[i] = 0;
  }
}

int checkTax (int tax) 
{
  if (tax == -1 || tax == 0 || tax == 3 || tax == 7 || tax == 22) 
    return 0;
  else
    return -1;
}
Tax getAllValueWithoutTax (InvoiceTax *inv)
{
  int a;
  Tax all;
  
  all = 0;
  
  for (a=0; a < 5; a++)
    all += inv->value_without_tax[a];

  return all;
}
Tax getAllValueWithTax (InvoiceTax *inv)
{
  int a;
  Tax all;
  
  all = 0;
  
  for (a=0; a < 5; a++)
    all += inv->value_with_tax[a];

  return all;
}
int addValueWithoutTax (int tax, Tax value, InvoiceTax *inv)
{
  if (checkTax (tax) == 0) {
    switch (tax) {
      case -1:
        inv->value_without_tax[0] += value;
	break;
      case 0:
        inv->value_without_tax[1] += value;
	break;
      case 3:
        inv->value_without_tax[2] += value;
	break;
      case 7:
        inv->value_without_tax[3] += value;
	break;
      case 22:
        inv->value_without_tax[4] += value;
	break;
    }	
    return 0;
  } else
    return -1;
};
int addValueWithTax (int tax, Tax value, InvoiceTax *inv)
{
  if (checkTax (tax) == 0) {
    switch (tax) {
      case -1:
        inv->value_with_tax[0] += value;
	break;
      case 0:
        inv->value_with_tax[1] += value;
	break;
      case 3:
        inv->value_with_tax[2] += value;
	break;
      case 7:
        inv->value_with_tax[3] += value;
	break;
      case 22:
        inv->value_with_tax[4] += value;
	break;
    }	
    return 0;
  } else
    return -1;
};

Tax getValueWithoutTax (int tax, InvoiceTax *inv)
{
  if (checkTax (tax) == 0) {
    switch (tax) {
      case -1:
        return inv->value_without_tax[0];
	break;
      case  0:
        return inv->value_without_tax[1];
	break;
      case  3:
        return inv->value_without_tax[2];
        break;
      case  7:
	return inv->value_without_tax[3];
	break;
      case  22:
	return inv->value_without_tax[4];
	break;
    }
  } else
    return -1;
}
Tax getValueWithTax (int tax, InvoiceTax *inv)
{
  if (checkTax (tax) == 0) {
    switch (tax) {
      case -1:
        return inv->value_with_tax[0];
	break;
      case  0:
        return inv->value_with_tax[1];
	break;
      case  3:
        return inv->value_with_tax[2];
        break;
      case  7:
	return inv->value_with_tax[3];
	break;
      case  22:
	return inv->value_with_tax[4];
	break;
    }
  } else
    return -1;
}
