#include "moduleInvoices.h"

GtkWidget *entry_discount;

void messageDiscount(GtkWidget *widget, xdfConnModule *conn_mod)
{
  GtkWidget *dialog1;
  GtkWidget *dialog_vbox1;
  GtkWidget *fixed1;
  GtkWidget *label1; 
  GtkWidget *dialog_action_area1;
  GtkWidget *button1;
  extern GtkWidget *clist2;
  GString *query = g_string_new ("");
  char *text;
  struct xdfDialogMsgStruct msg_struct;
  PGresult *res;

  
  msg_struct.type = GTK_MESSAGE_WARNING;

  /* Sprawdzam czy user dobrze wypelnil formularz */
  if (conn_mod->clients_row == -1) {
    msg_struct.msg  = g_string_new ("NIE ZAZNACZYLES NABYWCY !! \n\n\t XdeFactor-ng");
    xdfDialogMsg (&msg_struct);
    goto fail;
  } 
  msg_struct.msg = g_string_new ("");
 
  
  dialog1 = gtk_dialog_new ();
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog1", dialog1);
  gtk_window_set_title (GTK_WINDOW (dialog1), ("XdeFactor by Michal Ociepka"));
  gtk_window_set_policy (GTK_WINDOW (dialog1), TRUE, TRUE, FALSE);
  

  dialog_vbox1 = GTK_DIALOG (dialog1)->vbox;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_vbox1", dialog_vbox1);
  gtk_widget_show (dialog_vbox1);

  fixed1 = gtk_fixed_new ();
  gtk_widget_ref (fixed1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "fixed1", fixed1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (fixed1);
  gtk_box_pack_start (GTK_BOX (dialog_vbox1), fixed1, TRUE, TRUE, 0);

  entry_discount = gtk_entry_new ();
  gtk_widget_ref (entry_discount);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "entry_discount", entry_discount,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (entry_discount);
  gtk_fixed_put (GTK_FIXED (fixed1), entry_discount, 130, 32);
  gtk_widget_set_uposition (entry_discount, 120, 32);
  gtk_widget_set_usize (entry_discount, 158, 24);

  label1 = gtk_label_new ("Udziel rabatu      : \n (Podaj bez %)");
  gtk_widget_ref (label1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "label1", label1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (label1);
  gtk_fixed_put (GTK_FIXED (fixed1), label1, 8, 24);
  gtk_widget_set_uposition (label1, 8, 24);
  gtk_widget_set_usize (label1, 121, 42);

  dialog_action_area1 = GTK_DIALOG (dialog1)->action_area;
  gtk_object_set_data (GTK_OBJECT (dialog1), "dialog_action_area1", dialog_action_area1);
  gtk_widget_show (dialog_action_area1);
  gtk_container_set_border_width (GTK_CONTAINER (dialog_action_area1), 10);

  button1 = gtk_button_new_from_stock (GTK_STOCK_OK);
  gtk_widget_ref (button1);
  gtk_object_set_data_full (GTK_OBJECT (dialog1), "button1", button1,
                            (GtkDestroyNotify) gtk_widget_unref);
  gtk_widget_show (button1);
  gtk_box_pack_start (GTK_BOX (dialog_action_area1), button1, FALSE, FALSE, 0);
  gtk_widget_set_usize (button1, 106, 35);
  gtk_window_set_position(GTK_WINDOW (dialog1), GTK_WIN_POS_CENTER);


  gtk_signal_connect (GTK_OBJECT (button1), "clicked",
		      GTK_SIGNAL_FUNC (addGoods),
		      conn_mod);

  gtk_signal_connect_object(GTK_OBJECT (button1), "clicked",
                             GTK_SIGNAL_FUNC (gtk_widget_destroy),
			    dialog1);
  gtk_widget_show(dialog1);

  gtk_clist_get_text (GTK_CLIST (clist2), conn_mod->clients_row, 1, &text);
  g_string_printf (query, "SELECT discount
			   FROM
			   clients
			   WHERE
			   name = '%s' and
			   is_active='TRUE';",
			   text);
  res = PQexec (conn_mod->conn, query->str);
  ENTRY_SET_TEXT (entry_discount, PQgetvalue (res, 0, 0));

fail:
  g_string_free (query, TRUE);
  g_string_free (msg_struct.msg, TRUE);
  
}
