#ifndef __MODULE_INVOICES_H__
#define __MODULE_INVOICES_H__

#include <postgresql/libpq-fe.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <string.h>
#include "xdef.h"
#include "xdfDialogMsg.h"
#include "libfix5.h"
#include "invoiceTax.h"



#define ENTRY_GET_TEXT(entry) gtk_entry_get_text(GTK_ENTRY(entry))
#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a), b)
#define SPRZEDAWCA    "/etc/defactor-ng/x/sprzedawca.conf"
#define XDEFACTOR_NG  "/etc/defactor-ng/x/xdefactor-ng.conf"
#define INVOICE_NAME "xdefactor-ng.txt"
#define XDEFACTOR_NG_INFO "/etc/defactor-ng/x/xdefactor-ng_info.conf"
#define FAKTURA_VAT "Faktura VAT"
#define FAKTURA_VAT_PROFORMA "Faktura VAT - Proforma"

void moduleInvoices (xdfConnModule *conn_mod);

void timeoutAdd (xdfConnModule *con_mod);

void search (char *file_name, char *model, char *result);

void updateClientsClist (xdfConnModule *conn_mod);

void inWords (double amount, char *buffer);

void freeInvoiceStruct (GtkWidget *widget, xdfConnModule *conn_mod);

void createInvoice (xdfConnModule *conn_mod);

void updateGoodsClist (xdfConnModule *conn_mod);

void timeoutRemove (GtkWidget *widget);

void searchClientsNip (GtkWidget *widget, xdfConnModule *conn_mod);

void searchGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void addGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void remGoods (GtkWidget *widget, xdfConnModule *conn_mod);

void doShopping (GtkWidget *widget, xdfConnModule *conn_mod); 

void nrInvoices (xdfConnModule *conn_mod, GString *string); 

void insertSqlShopping (xdfConnModule *conn_mod);

void messagePrint (GtkWidget *widget, xdfConnModule *conn_mod);

void messageDiscount (GtkWidget *widget, xdfConnModule *conn_mod);
#endif /* __MODULE_INVOICES_H__ */
