#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include <errno.h>
#include <fcntl.h>
#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>

#ifndef __MODULE_LOGIN_H__
#define __MODULE_LOGIN_H__

#define ENTRY_GET_TEXT(entry) gtk_entry_get_text(GTK_ENTRY(entry))

struct xdfDialogMsgStruct
{
  GString *title;
  GString *msg;
  GtkMessageType type;
};
struct xdfConnModule
{
  PGconn *conn;
  int connect;
  int userID;
  GString *ip;
};

void moduleLogin (struct xdfConnModule *conn_mod);

int xdfCheckPasswd (GtkWidget *widget, struct xdfConnModule *conn_mod);

GtkWidget *xdfDialogMsg (struct xdfDialogMsgStruct *strDialog);


#endif /* __MODULE_LOGIN_H__ */
