#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <glib/glib.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include "xdef.h"
#include "xdfDialogMsg.h"

#ifndef __MODULE_MEANS_OF_TRANSPORT_H_
#define __MODULE_MEANS_OF_TRANSPORT_H_

#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a),b)
#define ENTRY_GET_TEXT(a) gtk_entry_get_text(GTK_ENTRY(a))

void moduleMeans (struct xdfConnModule *conn_mod);

void findMeansId (GtkWidget *widget, struct xdfConnModule *conn_mod);

void findMeansName (GtkWidget *widget, struct xdfConnModule *conn_mod);

void addMeans (GtkWidget *widget, struct xdfConnModule *conn_mod);

void cleanMeans (GtkWidget *widget);

void updateMeans (GtkWidget *widget, struct xdfConnModule *conn_mod);

void removeMeans (GtkWidget *widget, struct xdfConnModule *conn_mod);

void showMeansClist (GtkWidget *widget, struct xdfConnModule *conn_mod);

void updateFromClist (char *text, struct xdfConnModule *conn_mod);

#endif /* __MODULE_MEANS_OF_TRANSPORT_H_ */
