#include <stdio.h>
#include <stdlib.h>
#include <gtk/gtk.h>
#include <unistd.h>
#include <glib/glib.h>
#include <postgresql/libpq-fe.h>
#include <string.h>
#include "xdef.h"
#include "xdfDialogMsg.h"

#ifndef __MODULE_STORES_H_
#define __MODULE_STORES_H_

#define ENTRY_SET_TEXT(a,b) gtk_entry_set_text(GTK_ENTRY(a),b)
#define ENTRY_GET_TEXT(a) gtk_entry_get_text(GTK_ENTRY(a))

void moduleStores (struct xdfConnModule *conn_mod);

void findStoreId (GtkWidget *widget, struct xdfConnModule *conn_mod);

void findStoreName (GtkWidget *widget, struct xdfConnModule *conn_mod);

void addStore (GtkWidget *widget, struct xdfConnModule *conn_mod);

void cleanStore (GtkWidget *widget);

void updateStore (GtkWidget *widget, struct xdfConnModule *conn_mod);

void removeStore (GtkWidget *widget, struct xdfConnModule *conn_mod);

void showStoresClist (GtkWidget *widget, struct xdfConnModule *conn_mod);

void updateFromClist (char *text, struct xdfConnModule *conn_mod);

#endif /* __MODULE_STORES_H_ */
