#include "callbacks.h"

PGconn *conn;

int xdfConnSQL (xdfConnModule *conn_mod)
{
  gchar	pgHost[30],
	pgPort[6],
	*pgOptions=NULL,
	*pgTty=NULL,
	pgName[30],
	pgLogin[30],
	pgPass[30];
	
  if(!(open (DB, O_WRONLY))){
    g_print ("\n Nie moge otworzyc pliku %s\n", DB);
    exit (EXIT_FAILURE);
  }

  search (DB, "host", pgHost);
  search (DB, "port", pgPort);
  search (DB, "user", pgLogin);
  search (DB, "db_name", pgName);
  search (DB, "passwd", pgPass);
  if ( conn_mod->kind_of_conn == 1){
    conn_mod->conn = PQsetdbLogin (pgHost, pgPort, pgOptions, pgTty, pgName, pgLogin, pgPass);
    
  /* Sprawdz, czy polaczenie nastapilo poprawnie */
  if (PQstatus (conn_mod->conn) == CONNECTION_OK){
    PQexec (conn_mod->conn, "SET CLIENT_ENCODING TO 'UNICODE';");
    PQexec (conn_mod->conn, "SET DATESTYLE TO GERMAN;");
    conn=conn_mod->conn;
    return 0;
  }else
      return -1;
  }else{
      PQfinish (conn);
      return 0;
  }
}
