#include <stdio.h>
#include <stdlib.h>

#ifndef __INVOICE_TAX_H__
#define __INVOICE_TAX_H__

/* Liczba rodzajow podatku vat */
#define TAX_QUANTITY 5

typedef double Tax;

typedef struct {
  Tax value_without_tax[TAX_QUANTITY];
  Tax value_with_tax[TAX_QUANTITY];
} InvoiceTax;

/*
 * [0] - zw -- tutaj wartosc -1
 * [1] - 0
 * [2] - 3
 * [3] - 7
 * [4] - 22
 */

void initTax (InvoiceTax *inv);

int addValueWithoutTax (int tax, Tax value, InvoiceTax *inv);

int addValueWithTax (int tax, Tax value, InvoiceTax *inv);

Tax getValueWithoutTax (int tax, InvoiceTax *inv);

Tax getValueWithTax (int tax, InvoiceTax *inv);

Tax getAllValueWithoutTax (InvoiceTax *inv);

Tax getAllValueWithTax (InvoiceTax *inv);

#endif /* __INVOICE_TAX_H__ */
