
/* ---------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.  

   Copyright (c) 2001-2002 by Michal Ociepka <M.Ociepka@netsync.pl>

   For more info:
   http://xdefactor.netsync.pl
   --------------------------------------------------------------------- */

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "libfix5.h"


double fix5(double number)
{
  double dtmp,etmp,ftmp,difftmp;
  long diff;

  ftmp=dtmp=100*number;
  etmp=(long)dtmp;
  ftmp-=etmp;
  difftmp=ftmp-0.5;

  diff=100000000L*difftmp;

  if (!((long)(dtmp) % 2))
  {
    if (diff<=0) 
      return ((long)(dtmp)/(double)(100));
    else
      return ((long)(dtmp+1)/(double)(100));
  }
  else
  {
    if (diff<0)
      return ((long)(dtmp)/(double)(100));
    else
      return ((long)(dtmp+1)/(double)(100));
  }
}

