#ifndef __MODULE_ARCHIVE_INVOICES_H__
#define __MODULE_ARCHIVE_INVOICES_H__

#include <unistd.h>
#include <string.h>
#include <stdio.h>
#include <gdk/gdkkeysyms.h>
#include <gtk/gtk.h>
#include <postgresql/libpq-fe.h>
#include "xdef.h"
#include "xdfDialogMsg.h"
#include "invoiceTax.h"
#include "libfix5.h"

#define SPRZEDAWCA    "/etc/defactor-ng/x/sprzedawca.conf"
#define XDEFACTOR_NG  "/etc/defactor-ng/x/xdefactor-ng.conf"
#define INVOICE_NAME "xdefactor-ng.txt"
#define XDEFACTOR_NG_INFO "/etc/defactor-ng/x/xdefactor-ng_info.conf"
#define FAKTURA_VAT "Faktura VAT"
#define FAKTURA_VAT_PROFORMA "Faktura VAT - Proforma"

void findInvoices (GtkWidget *widget, xdfConnModule *conn_mod);

void inWords(double amount, char *buffer);
				
void removeInvoices (GtkWidget *widget, xdfConnModule *conn_mod);

void moduleArchiveInvoices (xdfConnModule *conn_mod);

void createInvoice (GtkWidget *widget, xdfConnModule *conn_mod);

void search(char *file_name, char *model, char *result);

#endif  /* __MODULE_ARCHIVE_INVOICES_H__ */

