#include "moduleGoods.h"

#define GLADE_HOOKUP_OBJECT(component,widget,name) \
  gtk_object_set_data_full (GTK_OBJECT (component), name, \
    gtk_widget_ref (widget), (GtkDestroyNotify) gtk_widget_unref)

#define GLADE_HOOKUP_OBJECT_NO_REF(component,widget,name) \
  gtk_object_set_data (GTK_OBJECT (component), name, widget)

void updateFromClist (char *id, xdfConnModule *conn_mod)
{
  GtkWidget *widget;
  extern GtkWidget *entry_search, *combo_entry1;

  ENTRY_SET_TEXT (entry_search, id);
  ENTRY_SET_TEXT (combo_entry1, "Numer ID");
  findGoods (widget, conn_mod);
}
void selectionGoodsClist  ( GtkWidget	*clist,
			    gint	row,
			    gint	column,
			    GdkEventButton *event,
			    xdfConnModule *conn_mod )
{
  gchar *text;

  gtk_clist_get_text (GTK_CLIST (clist), row, 0, &text);

  updateFromClist (text, conn_mod);
}
void updateGoodsClist (gpointer data, xdfConnModule *conn_mod)
{
  PGresult *res;
  gint i;
  gchar *result[2][7];

  res = PQexec (conn_mod->conn, "SELECT no, name, code, units, tax_vat, stores, store_state FROM goods_view WHERE kinds_of_goods='towar';");
  gtk_clist_clear ((GtkCList *) data);
  for (i=0; i < PQntuples(res); i++) {
    result[1][0] = PQgetvalue (res, i, 0);
    result[1][1] = PQgetvalue (res, i, 1);
    result[1][2] = PQgetvalue (res, i, 2);
    result[1][3] = PQgetvalue (res, i, 3);
    result[1][4] = PQgetvalue (res, i, 4);
    result[1][5] = PQgetvalue (res, i, 5);
    result[1][6] = PQgetvalue (res, i, 6);
    gtk_clist_append ((GtkCList *) data, result[1]);
  }
}
void showGoodsClist (GtkWidget *widget, xdfConnModule *conn_mod)
{
  GtkWidget *window;
  GtkWidget *scrolledwindow1;
  GtkWidget *clist1;
  GtkWidget *label1;
  GtkWidget *label2;
  GtkWidget *label3;
  GtkWidget *label4;
  GtkWidget *label5;
  GtkWidget *label6;
  GtkWidget *label7;

  window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
  gtk_window_set_title (GTK_WINDOW (window), ("Lista towarow -- XdeFactor-ng"));
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);

  scrolledwindow1 = gtk_scrolled_window_new (NULL, NULL);
  gtk_widget_show (scrolledwindow1);
  gtk_container_add (GTK_CONTAINER (window), scrolledwindow1);

  clist1 = gtk_clist_new (7);
  gtk_widget_show (clist1);
  gtk_container_add (GTK_CONTAINER (scrolledwindow1), clist1);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 0, 27);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 1, 172);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 2, 51);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 3, 80);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 4, 45);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 5, 42);
  gtk_clist_set_column_width (GTK_CLIST (clist1), 6, 36);
  gtk_clist_column_titles_show (GTK_CLIST (clist1));

  label1 = gtk_label_new ("ID");
  gtk_widget_show (label1);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 0, label1);
  gtk_label_set_justify (GTK_LABEL (label1), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label1), TRUE);

  label2 = gtk_label_new ("Nazwa");
  gtk_widget_show (label2);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 1, label2);
  gtk_label_set_justify (GTK_LABEL (label2), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label2), TRUE);

  label3 = gtk_label_new ("Kod");
  gtk_widget_show (label3);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 2, label3);
  gtk_label_set_justify (GTK_LABEL (label3), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label3), TRUE);

  label4 = gtk_label_new ("Jm");
  gtk_widget_show (label4);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 3, label4);
  gtk_label_set_justify (GTK_LABEL (label4), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label4), TRUE);

  label5 = gtk_label_new ("Podatek\nVAT [%]");
  gtk_widget_show (label5);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 4, label5);
  gtk_label_set_justify (GTK_LABEL (label5), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label5), TRUE);

  label6 = gtk_label_new ("Magazyn\n  numer");
  gtk_widget_show (label6);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 5, label6);
  gtk_label_set_justify (GTK_LABEL (label6), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label6), TRUE);

  label7 = gtk_label_new ("Ilosc");
  gtk_widget_show (label7);
  gtk_clist_set_column_widget (GTK_CLIST (clist1), 6, label7);
  gtk_label_set_justify (GTK_LABEL (label7), GTK_JUSTIFY_LEFT);
  gtk_label_set_line_wrap (GTK_LABEL (label7), TRUE);

  /* Store pointers to all widgets, for use by lookup_widget(). */
  GLADE_HOOKUP_OBJECT_NO_REF (window, window, "window");
  GLADE_HOOKUP_OBJECT (window, scrolledwindow1, "scrolledwindow1");
  GLADE_HOOKUP_OBJECT (window, clist1, "clist1");
  GLADE_HOOKUP_OBJECT (window, label1, "label1");
  GLADE_HOOKUP_OBJECT (window, label2, "label2");
  GLADE_HOOKUP_OBJECT (window, label3, "label3");
  GLADE_HOOKUP_OBJECT (window, label4, "label4");
  GLADE_HOOKUP_OBJECT (window, label5, "label5");
  GLADE_HOOKUP_OBJECT (window, label6, "label6");
  GLADE_HOOKUP_OBJECT (window, label7, "label7");

  updateGoodsClist (clist1, conn_mod);
  g_signal_connect (G_OBJECT (clist1), "select_row", G_CALLBACK (selectionGoodsClist), conn_mod);

  gtk_window_resize (GTK_WINDOW (window), 530, 150);
  gtk_window_set_position (GTK_WINDOW (window), GTK_WIN_POS_CENTER);
  gtk_widget_show (window);
}

