#!/bin/sh

XDEFACTOR_NG_CONF="/etc/defactor-ng/x/xdefactor-ng.conf"

rm $XDEFACTOR_NG_CONF
touch $XDEFACTOR_NG_CONF 

mkdir -p /etc/defactor-ng/x/modules
mkdir -p /usr/lib/xdefactor-ng
mkdir -p /usr/share/xdefactor-ng/images
mv /etc/defactor-ng/x/logo.jpg /usr/share/xdefactor-ng/images

echo "/usr/lib/xdefactor-ng" >> "/etc/ld.so.conf"
ldconfig

echo 
echo  "Witaj w instalatorze modulw dla XdeFactor-ng"
echo

# START -> moduy podstawowe - niezbdne
# start -> moduleLogin
echo "Instaluj modu moduleLogin"

cd modules/login
make
make install
cd -

echo "Zainstalowaem modu moduleLogin"
echo
# koniec -> moduleLogin

# start -> moduleLogout
echo "Instaluj modu moduleLogout"

cd modules/logout
make
make install
cd -

echo "Zainstalowaem modu moduleLogout"
echo
# koniec -> moduleLogout

# start -> moduleAbout
echo "Instaluj modu moduleAbout"

cd modules/about 
make
make install
cd -

echo "Zainstalowalem modu moduleAbout"
echo
# koniec -> moduleAbout
# KONIEC -> moduy podstawowe - niezbdne

# start -> moduleClients
echo "Czy chcesz zainstalowa modu moduleClients?"
echo "Dziki temu moduowi moesz kompleksowo zarzdza klientami"
echo "[t/n]"

read ANSWER

if expr "$ANSWER" = "t"
then
  echo "Instaluj modu moduleClients"
  cd modules/clients
  make
  make install
  cd -
  echo "Zainstalowaem modu moduleClients"
  echo
fi
# koniec -> moduleClients

# start -> moduleGoods
echo "Czy chcesz zainstalowa modu moduleGoods?"
echo "Dziki temu moduowi bdziesz mg zarzdza towarami/usugami"
echo "[t/n]"

read ANSWER

if expr "$ANSWER" = "t"
then
  echo "Instaluj modu moduleGoods"
  cd modules/goods
  make
  make install
  cd -
  echo "Zainstalowaem modu moduleGoods"
  echo
fi
# koniec -> moduleGoods

# start -> moduleInvoices
echo "Czy chcesz zainstalowa modu moduleInvoices?"
echo "Dziki niemu bdzisz mog wystawia faktury VAT"
echo "[t/n]"

read ANSWER

if expr "$ANSWER" = "t"
then
  echo "Instaluj modu moduleInvoices"
  cd modules/invoices
  make
  make install
  cd -
  echo "Zainstalowaem modu moduleInvoices"
  echo
  # zadaje pytania dotyczace konfiguracji moduleInvoices
  echo "Teraz musisz odpowiedzie na kilka pyta niezbdnych "
  echo "do konfiguracji powyszego moduu"
  echo 
  echo "W module tym wystpuj dwie listy:"
  echo "- pierwsza pokazujca nabywcw "
  echo "- druga pokazujca towary/usugi"
  echo "Ty decydujesz co jaki czas kada z tych list powinna si uaktualni!"

  echo "Podaj co ile sekund mam uaktualnia list nabywcw:"
  read ANSWER
    ANSWER=`expr $ANSWER \* 1000` 
    echo "invoices_clients_clist=$ANSWER" >> $XDEFACTOR_NG_CONF

  echo "Podaj co ile sekund mam uaktualnia list towarw/usug:"
  read ANSWER
    ANSWER=`expr $ANSWER \* 1000` 
    echo "invoices_goods_clist=$ANSWER" >> $XDEFACTOR_NG_CONF

  echo "Podaj prefiks numeru faktury wraz ze znakiem '/', np. 'MO/':"
  read ANSWER
    echo "prefix_nr_invoices=$ANSWER" >> $XDEFACTOR_NG_CONF

  echo "moduleInvoices akceptuje dwa rodzaje numerowa faktur VAT:"
  echo "- NR/YYYY      - numer faktury VAT amane przez rok"
  echo "- NR/MM/YYYY   - numer faktury VAT amane przez miesic, przez rok"
	echo "- YYYY/MM/NR	 - rok amana przez miesiac i numer faktury"
  echo "Podaj ktry sposb numerowania wybierasz, np. NR/YYYY:"
  read ANSWER
    echo "kind_of_nr_invoices=$ANSWER" >> $XDEFACTOR_NG_CONF

  echo "Na kocu kadej Faktury VAT, Proformy zobaczysz napis, moe on
	by dowolny, np. ZAPRASZAMY PONOWNIE!!. Ty decydujesz co XdeFactor-ng
	tam napisze! Wpisz wic teraz poniej ten tekst:"
  read INFO_TEXT
    echo "info_text=$INFO_TEXT" >> $XDEFACTOR_NG_CONF

  echo "Podaj pen sciek do programu drukujcego faktur wraz z jego parametrami:"
  echo "[a2ps -B -R --columns=1 -f 8 -n 2 -Xiso2]"
  read PRINT
  if [ "$PRINT" ]
  then
    echo "print_command=$PRINT" >> $XDEFACTOR_NG_CONF
  else
    echo "print_command=a2ps -B -R --columns=1 -f 8 -n 2 -Xiso2" >> $XDEFACTOR_NG_CONF
  fi
  echo 
fi
# koniec -> moduleInvoices

# start -> moduleMeansOfTransport
echo "Czy chcesz zainstalowa modu moduleMeansOfTransport?"
echo "Modu odpowiedzialny jest za operacje na rodkach transportu"
echo "[t/n]"
read ANSWER

if expr "$ANSWER" = "t"
then
  echo "Instaluj modu moduleMeansOfTransport"
  cd modules/means_of_transport
  make
  make install
  cd -
  echo "Zainstalowaem modu moduleMeansOfTransport"
  echo
fi
# koniec -> moduleMeansOfTransport
  
# start -> moduleStores
echo "Czy chcesz zainstalowa modu moduleStores?"
echo "Modu do obsugi magazynu"
echo "[t/n]"
read ANSWER

if expr "$ANSWER" = "t"
then
  echo "Instaluj modu moduleStores"
  cd modules/stores
  make
  make install
  cd -
  echo "Zainstalowaem modu moduleStores"
  echo
fi
# koniec -> moduleStores

#start -> moduleArchiveInvoices
echo "Czy chcesz zainstalowac modul moduleArchiveInvoices?"
echo "Modu ten sluzy do operacji na archiwalnych fakturach"
echo "[t/n]"
read ANSWER

if expr "$ANSWER" = "t"
then
	echo "Instaluje modul moduelArchiveInvoices"
	cd modules/archive_invoices
	make
	make install
	cd -
	echo "Zainstalowalem modul moduleArchiveInvoices"
	echo
fi
#koniec -> moduleArchiveInvoices

echo "DZIEKUJE!!!"
echo "Wlasnie zainstalowales zestaw modulw dla XdeFactor-ng"
echo "W razie problemow wyslij maila do:"
echo "		    <M.Ociepka@netsync.pl>"




