/*
Ponizej funkcja do generowania "slwonie". Makymalna kwota jaka
trawi to 999999.99 zl.
*/

#include <stdio.h>
#include <string.h>
#include "moduleInvoices.h"

void inWords(double amount, char *buffer)
{
  char amountStr[64], zloteStr[7], groszeStr[3];
  int i, zlote, grosze, tmp;
  
  char *setki[10]={"","sto ","dwiecie ","trzysta ","czterysta
","piset ",
    "szeset ","siedemset ","osiemset ","dziewiset "};
  char *dziesiatki[10]={"","dziesi","dwadziecia
","trzydzieci ","czterdzieci ",
    "pidziesit ","szedziesit ","siedemdziesit
","osiemdziesit ","dziewidziesit "};
  char *jednostki[10]={"", "jeden ","dwa ","trzy ","cztery
","pi ",
    "sze ","siedem ","osiem ","dziewi "};
  char *nastki[9]={"jedenacie ","dwanacie ","trzynacie
","czternacie ","pitnacie ",
    "szesnacie ","siedemnacie ","osiemnacie ","dziewitnacie
"};

  bzero (zloteStr, 7);
  bzero (groszeStr, 3);
  buffer[0]=0;

  sprintf (amountStr, "%.2f", amount);
  sscanf (amountStr, "%d.%d", &zlote, &grosze);
  sprintf (zloteStr, "%06d", zlote);
  sprintf (groszeStr, "%02d", grosze);

  tmp=(zloteStr[1]-48)*10+(zloteStr[2]-48);
  if ((tmp>10)&&(tmp<20))
  {
    strcat(buffer,nastki[zloteStr[2]-49]);
  }
  else
  {
    strcat(buffer,dziesiatki[zloteStr[1]-48]);
    strcat(buffer,jednostki[zloteStr[2]-48]);
  }

  tmp=(zloteStr[0]-48)*100+(zloteStr[1]-48)*10+(zloteStr[2]-48);
  if (tmp)
  {
    if (tmp==1)
      strcat (buffer,"tysiac ");
    else
      if (tmp<5)
        strcat (buffer,"tysiace ");
      else
        if ((tmp%100)<22)
          strcat (buffer,"tysiecy ");
        else
          if (((zloteStr[2]-48)>1)&&((zloteStr[2]-48)<5))
            strcat (buffer,"tysiace ");
          else
            strcat (buffer,"tysiecy ");
  }

  strcat(buffer,setki[zloteStr[3]-48]);

  tmp=(zloteStr[4]-48)*10+(zloteStr[5]-48);
  if ((tmp>10)&&(tmp<20))
  {
    strcat(buffer,nastki[zloteStr[5]-49]);
  }
  else
  {
    strcat(buffer,dziesiatki[zloteStr[4]-48]);
    strcat(buffer,jednostki[zloteStr[5]-48]);
  }

  tmp=(zloteStr[3]-48)*100+(zloteStr[4]-48)*10+(zloteStr[5]-48);
  if (tmp)
  {
    if (tmp==1)
      strcat (buffer,"zoty ");
    else
      if (((tmp%100)>1)&&((tmp%100)<5))
        strcat (buffer,"zote ");
      else
        if ((tmp%100)<22)
          strcat (buffer,"zotych ");
        else
          if (((zloteStr[5]-48)>1)&&((zloteStr[5]-48)<5))
            strcat (buffer,"zote ");
          else
            strcat (buffer,"zotych ");
  }
  else
    if
((zloteStr[0]-48)*100+(zloteStr[1]-48)*10+(zloteStr[2]-48))
      strcat (buffer, "zotych ");

  tmp=(groszeStr[0]-48)*10+(groszeStr[1]-48);
  if ((tmp>10)&&(tmp<20))
  {
    strcat(buffer,nastki[groszeStr[1]-49]);
  }
  else
  {
    strcat(buffer,dziesiatki[groszeStr[0]-48]);
    strcat(buffer,jednostki[groszeStr[1]-48]);
  }

  if (tmp)
  {
    if (tmp==1)
      strcat(buffer,"grosz");
    else
      if (tmp<5)
        strcat(buffer,"grosze");
      else
        if (tmp<22)
          strcat(buffer,"groszy");
        else
          if(((groszeStr[1]-48)>1)&&((groszeStr[1]-48)<5))
            strcat(buffer,"grosze");
          else
            strcat(buffer,"groszy");
  }
  else
  {
    strcat(buffer,"zero ");
    strcat(buffer,"groszy");
  }
  for (i=0; i < strlen(buffer); i++)
    if (buffer[i] == '\n')
      buffer[i] = ' ';
}

