#include "moduleInvoices.h"

void insertSqlShopping (xdfConnModule *conn_mod)
{
  extern GtkWidget *clist4, *clist2;
  extern GtkWidget *entry_nr_wz,
		   *entry_nr_invoice,
		   *entry_date_print,
		   *entry_days_of_pay,
		   *entry_date_sell,
		   *entry_place,
		   *entry_order,
		   *combo_pay,
		   *combo_kind_of_invoice,
		   *entry_days_of_pay,
		   *entry_people_get,
		   *entry_order;
		   
  gint rows;
  GString *nr_invoices = g_string_new (""); 
  char *text, *quantity, *discount, *nip;
  GString *prefix_number = g_string_new ("");
  GString *query = g_string_new ("");
  GString *term_of_pay = g_string_new ("");

  char buff[1024];

  rows = (GTK_CLIST (clist4))->rows;
  rows--;
  
  /* Pobieram nastepny numer faktury */
  if (strcmp ("", ENTRY_GET_TEXT (entry_nr_invoice)) == 0){
    nrInvoices (conn_mod, nr_invoices);
  } else {
    g_string_printf (nr_invoices, "%s", ENTRY_GET_TEXT (entry_nr_invoice));
  }
  g_string_printf (conn_mod->invoice_number, "%s", nr_invoices->str);

  /* 
   * Pobieram dane potrzebne do 
   * uzupelnienia tabeli invoices 
   */

  /* Prefix */
  search (XDEFACTOR_NG, "prefix_nr_invoices", buff);
  g_string_printf (prefix_number, "%s", buff);
  g_string_printf (conn_mod->invoice_prefix, "%s", prefix_number->str);
  /* NAZWA klienta */
  gtk_clist_get_text (GTK_CLIST (clist2), conn_mod->clients_row, 1, &text);
  /* NIP klienta */
  gtk_clist_get_text (GTK_CLIST (clist2), conn_mod->clients_row, 0, &nip);

  /* Rodzaj platnosci */
  
  /* 
   * Sprawdzam, czy jest przelew, czy gotowka 
   * Wyznaczam termin platnosci
   */
  
  if (strcmp ("Przelew", ENTRY_GET_TEXT (combo_pay)) == 0)
    g_string_printf (term_of_pay, "(SELECT DATE '%s' + %s)",
		     ENTRY_GET_TEXT (entry_date_sell),
		     ENTRY_GET_TEXT (entry_days_of_pay));
  else
    g_string_printf (term_of_pay, "'%s'", ENTRY_GET_TEXT(entry_date_sell));
 
  /* WRZUCAM DO BAZY -> invoices */
  g_string_printf (query, "INSERT INTO invoices (
			   clients_id,
			   kinds_of_pay,
			   users_id,
			   prefix_number,
			   number,
			   orders,
			   nr_wz,
			   sell_date,
			   print_date,
			   term_of_pay,
			   people_get,
			   invoices_kind_id,
			   place)
			   VALUES
			   ((SELECT id FROM clients WHERE name='%s' and nip='%s' and is_active='TRUE'),
			    (SELECT id FROM kinds_of_pay WHERE name='%s'),
			    %d,
			    '%s',
			    '%s',
			    '%s',
			    '%s',
			    '%s',
			    '%s',
			     %s,
			    '%s',
			    (SELECT id FROM invoices_kind WHERE name='%s'),
			    '%s');",
			    text,
			    nip,
			    ENTRY_GET_TEXT (combo_pay),
			    conn_mod->userID,
			    prefix_number->str,
			    nr_invoices->str,
			    ENTRY_GET_TEXT (entry_order),
			    ENTRY_GET_TEXT (entry_nr_wz),
			    ENTRY_GET_TEXT (entry_date_sell),
			    ENTRY_GET_TEXT (entry_date_print),
			    term_of_pay->str,
			    ENTRY_GET_TEXT (entry_people_get),
			    ENTRY_GET_TEXT (combo_kind_of_invoice),
			    ENTRY_GET_TEXT (entry_place)
			    );
  PQexec (conn_mod->conn, query->str);	       

  /*
   * Wpisuje do bazy transakcje towarw 
   */

  while (rows >= 0) {
    /* odczytuje ID towaru */
    gtk_clist_get_text (GTK_CLIST(clist4), rows, 0, &text); 
    gtk_clist_get_text (GTK_CLIST(clist4), rows, 3, &quantity); 

    g_string_printf (query, "INSERT INTO invoice_goods
			     (invoices_id, 
			      goods_id,
			      goods_data_id,
			      quantity) VALUES (
			     (SELECT id FROM invoices
			      WHERE 
			        prefix_number = '%s' and
			        number = '%s' and
							invoices_kind_id = (SELECT id FROM invoices_kind WHERE name = '%s') and
			        is_active = 'TRUE'),
			     (SELECT goods.id FROM goods, goods_data 
			      WHERE 
				no='%s' and
				goods.id=goods_data.goods_id and
				goods.is_active='TRUE'),
			     (SELECT goods_data.id FROM goods_data, goods 
			      WHERE 
				no='%s' and
				goods.is_active='TRUE' and
				goods.id=goods_data.goods_id),
			     '%s');",
			    prefix_number->str,
			    nr_invoices->str,
					ENTRY_GET_TEXT (combo_kind_of_invoice),
			    text,
			    text,
			    quantity);
    PQexec (conn_mod->conn, query->str);			    

    /* Wrzucam do bazy rabaty */
    gtk_clist_get_text (GTK_CLIST(clist4), rows, 6, &discount); 

    g_string_printf (query, "INSERT INTO discounts (
    			     invoice_goods_id,
			     discount
			     ) VALUES (
			     (SELECT invoice_goods.id 
			       FROM invoices, invoice_goods, goods_data
			       WHERE
				 invoices.id=invoice_goods.invoices_id and
				 invoices.is_active='TRUE' and
				 invoices.invoices_kind_id = (SELECT id FROM invoices_kind WHERE name = '%s') and
				 invoices.prefix_number='%s' and
				 invoices.number='%s' and
				 no='%s' and
				 goods_data.goods_id=invoice_goods.goods_id
			     ), '%s');",
					 ENTRY_GET_TEXT (combo_kind_of_invoice),
			     prefix_number->str,
			     nr_invoices->str,
			     text,
			     discount);

    PQexec (conn_mod->conn, query->str);
			     
    rows--;
  }

  conn_mod->clients_row = -1;
  g_string_free (nr_invoices, TRUE);
  g_string_free (query, TRUE);
  g_string_free (term_of_pay, TRUE);
  updateClientsClist (conn_mod);
  gtk_clist_clear(GTK_CLIST (clist4));

}

