#include "moduleInvoices.h"

#define NR_LONG 10

char *reverse (char *text)
{
	char *new, *next;

	new = (char *)malloc(NR_LONG);
	next=new;

	text += 8; //tyle trzeba przeskoczyc znakow
	
	while (*text != '\0') 
		*(new++) = *(text++);

	*new='\0';
	
	return next;
}	
		
void nrInvoices (xdfConnModule *conn_mod, GString *string)
{
  struct tm *loctime;
  time_t curtime;
  char year[128];
	char year_[128];
  char prefix[128];
  extern GtkWidget *combo_kind_of_invoice;
  GString *query = g_string_new ("");
  long max_number;
  int a;
  PGresult *res;
  

  curtime = time (NULL);
  loctime = localtime (&curtime);

  max_number = 0;

  /* 
   * szukam prefixu faktury
   * i dodaje go do numeru faktury
   */
  search (XDEFACTOR_NG, "prefix_nr_invoices", prefix);

  /* szukam rodzaju numerowania faktur */
   
  search (XDEFACTOR_NG, "kind_of_nr_invoices", year_);
  
  if (strcmp ("NR/YYYY", year_) == 0) 
    strftime (year, 128, "/%Y", loctime);
  
  if (strcmp ("NR/MM/YYYY", year_) == 0) 
    strftime (year, 128, "/%m/%Y", loctime);
  
	if (strcmp ("YYYY/MM/NR", year_) == 0) 
		strftime (year, 128, "%Y/%m/", loctime);
	
  /* 
   * Wyciagam z bazy danych najwiekszy numer faktury 
   * Jesli brak wpisu zaczynam od numeru 1
   * w przeciwnym wypadku sam znajduje kolejny numer
   */
  
  
  g_string_printf (query,
		    "SELECT invoices.number 
		    FROM
		    invoices, invoices_kind
		    WHERE 
		    invoices.invoices_kind_id=invoices_kind.id and
		    invoices_kind.name='%s' and
		    is_active='TRUE' and
		    prefix_number = '%s' and
		    number LIKE '%%%s%%';",
		    ENTRY_GET_TEXT (combo_kind_of_invoice),
		    prefix, year);
  res = PQexec (conn_mod->conn, query->str);


  if (PQgetisnull (res, 0, 0))  {
		if (strcmp ("YYYY/MM/NR", year_) == 0) {
			g_string_append (string, year);
			g_string_append (string, "1");
		}
		else
			g_string_append (string, "1");
  }else{
    for (a=0; a < PQntuples (res); a++) {
			if (strcmp ("YYYY/MM/NR", year_) == 0) {
				if (max_number < atol ( reverse (PQgetvalue (res, a, 0)))) 
					max_number = atol (reverse (PQgetvalue (res, a, 0)));
			}
			else
      if (max_number < atol (PQgetvalue (res, a, 0)))
         max_number = atol (PQgetvalue (res, a, 0));
      }
		if (strcmp ("YYYY/MM/NR", year_) == 0) 
			g_string_append (string, year);
		
    sprintf (prefix, "%ld", ++max_number);
    g_string_append (string, prefix);
  } 
	if (strcmp ("YYYY/MM/NR", year_) != 0) 
	  g_string_append (string, year);
  
  g_string_free (query, TRUE);
}
