#ifndef __XDFDIALOGMSG_H__
#define __XDFDIALOGMSG_H__

/** 
  Struktura dla funkcji xdfDialogMsg odpowiedzalna za wyswietlenie stosownego powiedomienia.
  @param title tytul okna
  @param msg wiadomosc do przekazania
  @param type typ wiadomosci, zalezny of GTK+ (m.in. GTK_MESSAGE_{INFO|WARNING|ERROR|QUESTION)
  @author Michal Ociepka
  @version 0.1
*/
struct xdfDialogMsgStruct
{
  GString *title;
  GString *msg;
  GtkMessageType type;
};

GtkWidget *xdfDialogMsg (struct xdfDialogMsgStruct *strDialog);

#endif /* __XDFDIALOGMSG_H__ */
